<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="流程名称" prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入流程名称" clearable size="small"
          @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="开始时间" prop="deployTime">
        <el-date-picker clearable size="small" v-model="queryParams.deployTime" type="date" value-format="yyyy-MM-dd"
          placeholder="选择时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="标题">
        <el-input v-model="searchText" size="small" @input="filterTitle()" clearable placeholder="仅搜索当前页面标题"></el-input>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-if="dataShow" v-loading="loading" :data="filterList" border @selection-change="handleSelectionChange">
      <el-table-column type="index" label="序号" width="55" align="center" />
      <!-- <el-table-column label="任务编号" align="center" prop="taskId" :show-overflow-tooltip="true" /> -->
      <el-table-column label="流程名称" align="center" prop="procDefName" />
      <el-table-column label="标题" align="center" prop="title" min-width="250" />
      <el-table-column label="当前节点" align="center" prop="taskName" />
      <!-- <el-table-column label="流程版本" align="center">
        <template slot-scope="scope">
          <el-tag size="medium">v{{ scope.row.procDefVersion }}</el-tag>
        </template>
</el-table-column> -->
      <el-table-column label="流程发起人" align="center">
        <template slot-scope="scope">
          <label>{{ scope.row.startUserName }} <el-tag type="info" size="mini">{{ scope.row.startDeptName
              }}</el-tag></label>
        </template>
      </el-table-column>
      <el-table-column label="接收时间" align="center" prop="createTime" width="180" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="160">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit-outline"
            @click="handleProcess(scope.row)">处理</el-button>
          <el-button size="mini" type="text" icon="el-icon-share" @click="handleAssign(scope.row)">转办</el-button>
        </template>
      </el-table-column>
    </el-table>

    <div class="mt20" style="font-size:12px;color:#e45656;text-align:right;">
      tips:标题搜索只搜索当前页码列表，可在右下角调整每页条数，若当前页面未查询到，可点击下一页;</div>
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />
    <!--选择流程接收人-->
    <el-dialog :title="taskTitle" :visible.sync="taskOpen" width="65%" append-to-body>
      <flow-user v-if="checkSendUser" :checkType="checkType" @handleUserSelect="handleUserSelect" />
      <span slot="footer" class="dialog-footer">
        <el-button @click="taskOpen = false">取 消</el-button>
        <el-button type="primary" @click="submitTask">提 交</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import { todoList, complete, returnList, returnTask, rejectTask, assignTask, getDeployment, delDeployment, exportDeployment } from "@/api/flowable/todo";
import { getProcessVariables } from "@/api/flowable/definition"
import { getProject, addProject, delProject } from "@/api/oa/project/project";
import FlowUser from '@/components/flow/User'
import FlowRole from '@/components/flow/Role'
export default {
  name: "Deploy",
  components: {
    FlowUser,
    FlowRole,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 流程待办任务表格数据
      todoList: [],
      filterList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: null,
        category: null
      },
      searchText: '',
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      dataShow: true,
      taskTitle: null,
      taskOpen: false,
      checkSendUser: false, // 是否展示人员选择模块
      checkType: '', // 选择类型
      checkValues: null, // 选中任务接收人员数据
      taskId: '',
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询流程定义列表 */
    getList() {
      this.loading = true;
      todoList(this.queryParams).then(response => {
        this.todoList = response.data.records;
        this.filterList = response.data.records;
        this.total = response.data.total;
        this.filterTitle();
        this.loading = false;
      });
    },
    filterTitle() {
      this.filterList = this.todoList.filter(data => {
        if (data.title) {
          return !this.searchText || data.title.toLowerCase().includes(this.searchText.toLowerCase())
        } else {
          return data
        }
      })
    },
    getProjectInfo(row) {
      getProcessVariables(row.taskId).then(res => {
        if (res.data) {
          getProject(res.data.formId).then(result => {
            if (res.data) {
              let name = result.data.projectNumber + '-' + result.data.projectName
              this.todoList.map(item => {
                if (item.taskId == row.taskId) {
                  this.$set(item, 'project', name)
                }
              })
            }
          })
        }
      })
    },
    handleAssign(row) {
      this.taskOpen = true;
      this.taskTitle = "选择任务接收";
      this.checkSendUser = true;
      this.checkType = "single";
      this.taskId = row.taskId;
    },
    /** 提交流程 */
    submitTask() {
      if (!this.checkValues && this.checkSendUser) {
        this.$modal.msgError("请选择任务接收!");
        return;
      }
      assignTask({ taskId: this.taskId, assignee: this.checkValues }).then(res => {
        this.$modal.msgSuccess(res.msg);
        this.taskOpen = false;
        this.getList();
      })
    },
    // 用户信息选中数据
    handleUserSelect(selection) {
      if (selection) {
        this.checkValues = selection.userId;
      }
    },
    // 跳转到处理页面
    handleProcess(row) {
      let path = this.getRoutePath(row);
      if (this.$store.getters.userId == 1 && row.procDefName == '项目预算') {
        path = '/applyForm/budgetApply'
      }
      getProcessVariables(row.taskId).then(res => {
        this.$router.push({
          path: path,
          query: {
            procInsId: row.procInsId,
            executionId: row.executionId,
            deployId: row.deployId,
            taskId: row.taskId,
            taskName: row.taskName,
            startUser: row.startUserName + '-' + row.startDeptName,
            formId: res.data.formId,
            procDefName: row.procDefName
          }
        })
      })

    },
    getRoutePath(row) {
      let path;
      for (let p of this.publicData.pathRoute) {
        if (p.name == row.procDefName) {
          path = p.path
          break
        } else {
          path = '/flowable/task/todo/detail/index'
        }
      }
      return path
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        name: null,
        category: null,
        key: null,
        tenantId: null,
        deployTime: null,
        derivedFrom: null,
        derivedFromRoot: null,
        parentDeploymentId: null,
        engineVersion: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.taskId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.taskId || this.ids;
      this.$confirm('是否确认删除流程定义编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delDeployment(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      })
    }
  }
};
</script>
